import '@things-factory/form-ui'
import '@things-factory/grist-ui'
import '../inventory/inventory-by-product-detail'

import gql from 'graphql-tag'
import { css, html } from 'lit-element'
import { connect } from 'pwa-helpers/connect-mixin'

import { getCodeByName } from '@things-factory/code-base'
import { i18next, localize } from '@things-factory/i18n-base'
import { client, gqlContext, PageView, store } from '@things-factory/shell'
import { flattenObject, isMobileDevice } from '@things-factory/utils'

function formatLocalDate(date = new Date()) {
  const year = date.getFullYear()
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const day = String(date.getDate()).padStart(2, '0')
  return `${year}-${month}-${day}`
}

class CostingReport extends connect(store)(localize(i18next)(PageView)) {
  static get styles() {
    return css`
      :host {
        display: flex;
        flex-direction: column;
        width: 100%;
      }

      data-grist {
        overflow-y: auto;
        flex: 1;
      }

      .summary {
        background-color: var(--main-section-background-color);
        display: flex;
        flex-direction: column;
        overflow-y: auto;
        align-items: flex-end;
        padding: var(--data-list-item-padding);
        display: grid;
        font-size: 14px;
        color: #394e64;
        grid-template-columns: repeat(2, 1fr);
        grid-auto-rows: minmax(24px, auto);
      }
    `
  }

  static get properties() {
    return {
      _searchFields: Object,
      _config: Object,
      _partners: Object,
      _gristData: Object,
      data: Object
    }
  }

  get context() {
    return {
      title: 'Costing Report',
      exportable: {
        name: i18next.t('title.costing_report'),
        data: this._exportableData.bind(this)
      },
      help: 'operato-wms/report/costing-report'
    }
  }

  get dataGrist() {
    return this.shadowRoot.querySelector('data-grist')
  }

  get searchForm() {
    return this.shadowRoot.querySelector('search-form')
  }

  get _bizplaceSelector() {
    return this.searchForm.shadowRoot.querySelector('select[name=bizplace]')
  }

  get _fromDateInput() {
    return this.searchForm.shadowRoot.querySelector('input[name=fromDate]')
  }

  get _toDateInput() {
    return this.searchForm.shadowRoot.querySelector('input[name=toDate]')
  }

  get searchFields() {
    return [
      {
        label: i18next.t('field.company'),
        name: 'bizplace',
        type: 'select',
        options: [
          { value: '' },
          ...this._partners
            .map(partner => {
              return {
                name: `${partner.name} ${partner.description ? `(${partner.description})` : ''}`,
                value: partner.id
              }
            })
            .sort(this._compareValues('name', 'asc'))
        ],
        props: { searchOper: 'eq' }
      },
      {
        label: i18next.t('field.from_date'),
        name: 'fromDate',
        type: 'date',
        props: {
          searchOper: 'eq',
          max: formatLocalDate(new Date())
        },
        value: (() => {
          const date = new Date()
          date.setMonth(date.getMonth() - 1)
          return formatLocalDate(date)
        })(),
        handlers: { change: this._modifyDateRange.bind(this) }
      },
      {
        label: i18next.t('field.to_date'),
        name: 'toDate',
        type: 'date',
        props: {
          searchOper: 'eq',
          min: (() => {
            const date = new Date()
            date.setMonth(date.getMonth() - 1)
            return formatLocalDate(date)
          })(),
          max: (() => {
            const max = new Date()
            max.setMonth(max.getMonth() + 1)
            return formatLocalDate(max)
          })()
        },
        value: formatLocalDate(new Date())
        // handlers: { change: this._submit.bind(this) }
      }
    ]
  }

  get reportConfig() {
    let columns = [
      { type: 'gutter', gutterName: 'sequence' },
      {
        type: 'string',
        name: 'bizplace|name',
        header: i18next.t('field.company'),
        width: 200
      },
      {
        type: 'string',
        name: 'product|sku',
        header: i18next.t('field.sku'),
        width: 150
      },
      {
        type: 'string',
        name: 'product|name',
        header: i18next.t('field.product_name'),
        width: 200
      },
      {
        type: 'string',
        name: 'product|description',
        header: i18next.t('field.product_description'),
        width: 300
      },
      {
        type: 'string',
        name: 'product|type',
        header: i18next.t('field.product_type'),
        width: 150
      },
      {
        type: 'float',
        name: 'qty',
        header: i18next.t('field.qty'),
        width: 120
      },
      {
        type: 'float',
        name: 'uomValue',
        header: i18next.t('field.uom_value'),
        width: 120
      },
      {
        type: 'string',
        name: 'uom',
        header: i18next.t('field.uom'),
        width: 100
      },
      {
        type: 'string',
        name: 'weightedAvgUnitCost',
        header: 'Weighted Avg Unit Cost',
        width: 100
      },
      {
        type: 'string',
        name: 'totalCost',
        header: i18next.t('field.total_cost'),
        width: 100
      }
    ]
    let list = {
      fields: [
        'bizplace|name',
        'product|sku',
        'product|name',
        'product|description',
        'product|type',
        'qty',
        'uomValue',
        'uom',
        'weightedAvgUnitCost',
        'totalCost'
      ]
    }

    return {
      columns: columns,
      list,
      pagination: { limit: 100, pages: [100, 200, 500, 1000] },
      rows: {
        selectable: false,
        insertable: false,
        appendable: false
      }
    }
  }

  render() {
    return html`
      <search-form id="search-form" .fields=${this._searchFields} @submit=${e => this.dataGrist.fetch()}></search-form>

      <data-grist
        .mode=${isMobileDevice() ? 'LIST' : 'GRID'}
        .config=${this._config}
        .fetchHandler="${this.fetchHandler.bind(this)}"
      ></data-grist>
    `
  }

  async pageInitialized() {
    this._gristData = { total: 0, records: [] }
    this._products = []

    const [_partnersReq] = await Promise.allSettled([this._fetchPartners()])

    this._partners = _partnersReq.status == 'fulfilled' ? _partnersReq.value : []

    this._searchFields = this.searchFields
    this._config = this.reportConfig
  }

  async pageUpdated(changes, lifecycle) {
    if (this.active) {
      this.dataGrist.fetch()
    }
  }

  async fetchHandler({ page, limit, sorters = [] }) {
    try {
      this._validate()
      let filters = this.searchForm.queryFilters.map(filter => {
        switch (filter.name) {
          case 'fromDate':
            let fromDt = new Date(filter.value)
            fromDt.setHours(0)
            filter.value = fromDt.toISOString()
            break
          case 'toDate':
            let toDt = new Date(filter.value)
            toDt.setHours(23, 59, 59)
            filter.value = toDt.toISOString()
            break
          default:
            break
        }
        return filter
      })

      const pagination = { page, limit }
      const sortings = sorters

      const response = await client.query({
        query: gql`
          query costingReport($filters: [Filter!], $pagination: Pagination, $sortings: [Sorting!]) {
            costingReport(filters: $filters, pagination: $pagination, sortings: $sortings) {
              items {
                bizplace {
                  name
                  description
                }
                product {
                  sku
                  name
                  description
                  type
                }
                qty
                uomValue
                uom
                weightedAvgUnitCost
                totalCost
              }
              total
            }
          }
        `,
        variables: { filters, pagination, sortings },
        context: gqlContext()
      })

      const data = {
        total: response.data.costingReport.total,
        records:
          response.data.costingReport.items.map(itm => {
            itm = {
              ...itm,
              weightedAvgUnitCost: parseFloat(itm.weightedAvgUnitCost ? itm.weightedAvgUnitCost : 0).toFixed(4),
              totalCost: parseFloat(itm.totalCost ? itm.totalCost : 0).toFixed(4)
            }
            return flattenObject({ ...itm, bizplace: { name: `${itm.bizplace.name} ${itm.bizplace.description}` } })
          }) || []
      }

      this._gristData = {
        ...data
      }

      return data
    } catch (e) {
      this._showToast(e)
    }
  }

  async _fetchPartners() {
    const filters = []
    const response = await client.query({
      query: gql`
        query partnersBizplaces($filters: [Filter!]) {
          partnersBizplaces(filters: $filters) {
            items {
              id
              name
              description
            }
          }
        }
      `,
      variables: { filters }
    })

    if (!response.errors) {
      return response.data.partnersBizplaces.items
    }
  }
  _validate() {
    if (!this.searchForm.shadowRoot.querySelector('form').checkValidity())
      throw new Error(i18next.t('text.invalid_form_value'))
    if (!this._bizplaceSelector.value) throw new Error(i18next.t('text.no_company_selected'))
    if (!this._fromDateInput.value) throw new Error(i18next.t('text.from_date_is_empty'))
    if (!this._toDateInput.value) throw new Error(i18next.t('text.to_date_is_empty'))
  }

  _compareValues(key, order = 'asc') {
    return function innerSort(a, b) {
      if (!a.hasOwnProperty(key) || !b.hasOwnProperty(key)) {
        return 0
      }

      const varA = typeof a[key] === 'string' ? a[key].toUpperCase() : a[key]
      const varB = typeof b[key] === 'string' ? b[key].toUpperCase() : b[key]

      let comparison = 0
      if (varA > varB) {
        comparison = 1
      } else if (varA < varB) {
        comparison = -1
      }
      return order === 'desc' ? comparison * -1 : comparison
    }
  }

  _modifyDateRange(e) {
    const fromDate = e.currentTarget.value

    const minDate = new Date(fromDate)
    if (Number.isNaN(minDate.getTime())) return

    const maxDate = new Date(minDate)
    maxDate.setMonth(maxDate.getMonth() + 2)

    const min = formatLocalDate(minDate)
    const max = formatLocalDate(maxDate)

    if (this._toDateInput.value < fromDate) this._toDateInput.value = fromDate
    if (this._toDateInput.value > max) this._toDateInput.value = max

    this._toDateInput.max = max
    this._toDateInput.min = min
    this._submit()
  }

  _submit(e) {
    this._config = { ...this.reportConfig }
    this.searchForm.submit()
  }

  async _exportableData() {
    try {
      var headerSetting = [
        { header: i18next.t('field.company'), key: 'bizplace|name', width: 60, type: 'string' },
        { header: i18next.t('field.sku'), key: 'product|sku', width: 25, type: 'string' },
        { header: i18next.t('field.product_name'), key: 'product|name', width: 50, type: 'string' },
        { header: i18next.t('field.product_description'), key: 'product|description', width: 50, type: 'string' },
        { header: i18next.t('field.product_type'), key: 'product|type', width: 30, type: 'string' },
        { header: i18next.t('field.qty'), key: 'qty', width: 15, type: 'string' },
        { header: i18next.t('field.uom_value'), key: 'uomValue', width: 15, type: 'string' },
        { header: i18next.t('field.uom'), key: 'uom', width: 15, type: 'string' },
        { header: 'Weighted Avg Unit Cost', key: 'weightedAvgUnitCost', width: 15, type: 'string' },
        { header: i18next.t('field.total_cost'), key: 'totalCost', width: 15, type: 'string' }
      ]

      var exportData = {
        header: [...headerSetting],
        data: (await this.fetchHandler({ page: 1, limit: 9999999 })).records.map(itm => {
          return {
            ...itm
          }
        })
      }

      return exportData
    } catch (e) {
      this._showToast(e)
    }
  }

  _showToast({ type, message }) {
    document.dispatchEvent(
      new CustomEvent('notify', {
        detail: {
          type,
          message
        }
      })
    )
  }
}

window.customElements.define('costing-report', CostingReport)
